package org.wso2.wsas.persistence.dao;

import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.wsas.persistence.dataobject.BindingMessageDO;
import org.wso2.wsas.util.HibernateConfig;

public class BindingMessageDAO extends BaseDAO {
	private static final Log log = LogFactory.getLog(BindingMessageDAO.class);

	public BindingMessageDAO(HibernateConfig hbConfig) {
		super(hbConfig);
	}

	public void updateBindingMessage(BindingMessageDO bindingMessage) {
		Session session = hbConfig.currentSession();
		Transaction tx = session.beginTransaction();
		try {
			bindingMessage.setLastUpdatedTime(new Date());
			session.merge(bindingMessage);
			tx.commit();
		} catch (Throwable e) {
			tx.rollback();
			String m = "Unable to update BindingMessage";
			log.error(m, e);
			throw new RuntimeException(m, e);
		}
	}
}
