package org.wso2.wsas.persistence.dao;

import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.wsas.persistence.dataobject.BindingOperationDO;
import org.wso2.wsas.util.HibernateConfig;

public class BindingOperationDAO extends BaseDAO {

	private static final Log log = LogFactory.getLog(BindingOperationDAO.class);

	public BindingOperationDAO(HibernateConfig hbConfig) {
		super(hbConfig);
	}

	public void updateBindingOperation(BindingOperationDO bindingOperation) {
		Session session = hbConfig.currentSession();
		Transaction tx = session.beginTransaction();
		try {
			bindingOperation.setLastUpdatedTime(new Date());
			session.merge(bindingOperation);
			tx.commit();
		} catch (Throwable t) {
			tx.rollback();
			String m = "Unable to update BindingOperation";
			log.error(m, t);
			throw new RuntimeException(m, t);
		}
	}

}
