/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.wsas.persistence.dataobject;

/**
 * Data object representing policy of a service
 */
public class ServicePolicyDO extends AbstractDataObject {
	
	public static final int ANON_POLICY = 100;

    public static final int AXIS_POLICY = 1;

    public static final int AXIS_MODULE_POLICY = 2;
    
    public static final int AXIS_MODULE_OPERATION_POLICY = 17;

    public static final int AXIS_SERVICE_POLICY = 3;

    public static final int AXIS_OPERATION_POLICY = 4;

    public static final int AXIS_MESSAGE_POLICY = 5;

    public static final int SERVICE_POLICY = 6;

    public static final int PORT_POLICY = 7;

    public static final int PORT_TYPE_POLICY = 8;

    public static final int BINDING_POLICY = 9;

    public static final int OPERATION_POLICY = 10;

    public static final int BINDING_OPERATION_POLICY = 11;

    public static final int INPUT_POLICY = 12;

    public static final int OUTPUT_POLICY = 13;

    public static final int BINDING_INPUT_POLICY = 14;

    public static final int BINDING_OUTPUT_POLICY = 15;

    public static final int MESSAGE_POLICY = 16;
    
    public static final int SOAP11_BINDING = 101;
    public static final int SOAP11_BINDING_OPERATION = 102;
    public static final int SOAP11_BINDING_IN_MSG = 103;
    public static final int SOAP11_BINDING_OUT_MSG = 104;
    
    public static final int SOAP12_BINDING = 105;
    public static final int SOAP12_BINDING_OPERATION = 106;
    public static final int SOAP12_BINDING_IN_MSG = 107;
    public static final int SOAP12_BINDING_OUT_MSG = 108;
    
    public static final int HTTP_BINDING = 109;
    
    private String policy;
    private String uuid;
    private int type;
    private ServiceDO service;

    public ServicePolicyDO() {
    }

    public String getPolicy() {
        return policy;
    }

    public void setPolicy(String policy) {
        this.policy = policy;
    }

    public String getUuid() {
        return uuid;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public ServiceDO getService() {
        return service;
    }

    public void setService(ServiceDO service) {
        this.service = service;
    }

    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj instanceof ServicePolicyDO) {
            ServicePolicyDO servicePolicyDO = (ServicePolicyDO) obj;
            if ((service == null) || servicePolicyDO.getService() == null) {
                return false;
            }
            return servicePolicyDO.getUuid().equals(uuid) &&
                   service.equals(servicePolicyDO.getService());
        }
        return false;
    }

    public int hashCode() {
        return uuid.hashCode();
    }
}
