package org.wso2.wsas.util;

import org.apache.axiom.soap.SOAP11Constants;
import org.apache.axiom.soap.SOAP12Constants;
import org.apache.axis2.description.AxisBinding;
import org.apache.axis2.description.WSDL2Constants;
import org.apache.axis2.description.java2wsdl.Java2WSDLConstants;

public class BindingUtil {
	public static boolean isSoap11Binding(AxisBinding binding) {
		String type = binding.getType();
		if (Java2WSDLConstants.TRANSPORT_URI.equals(type)
				|| WSDL2Constants.URI_WSDL2_SOAP.equals(type)) {
			String v = (String) binding
					.getProperty(WSDL2Constants.ATTR_WSOAP_VERSION);
			if (SOAP11Constants.SOAP_ENVELOPE_NAMESPACE_URI.equals(v)) {
				return true;
			}
		}
		return false;
	}
	
	public static boolean isSoap12Binding(AxisBinding binding) {
		String type = binding.getType();
		if (Java2WSDLConstants.TRANSPORT_URI.equals(type)
				|| WSDL2Constants.URI_WSDL2_SOAP.equals(type)) {
			String v = (String) binding
					.getProperty(WSDL2Constants.ATTR_WSOAP_VERSION);
			if (SOAP12Constants.SOAP_ENVELOPE_NAMESPACE_URI.equals(v)) {
				return true;
			}
		}
		return false;
	}
	
	public static boolean isHttpBinding(AxisBinding binding) {
		String type = binding.getType();
		if (WSDL2Constants.URI_WSDL2_HTTP.equals(type)) {
			return true;
		}
		return false;
	}
}
