/*
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.ws.dataservice.ide.context;

import java.lang.reflect.Method;
import java.util.List;
/**
 * Interface for Data Service Configuration Persistence
 */
public interface DSContext {

	public final String PREFERENCE_DS_CONFIG = "dataServiceConfig";
	
	public final String PREFERENCE_CARBON_HOME = "carbonHome";

	public String getDSConfig();

	public void setDSConfig(String dsConfig);
	
	public String getCarbonHome();

	public void setCarbonHome(String serviceName);
	
	public String getServiceName();

	public void setServiceName(String serviceName);
	
	public List getQueryData();
	
	public void setQueryData(List queryData);
	
	public List getOperationData();
	
	public void setOperationData(List operationData);
	
	public void updateOperationDataOnXml();
	
	public void setMethodForUpdateOperationDataOnXml(Method method, Object methodOwningInstance);

}
