/*
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.ws.dataservice.ide.context;

import org.wso2.ws.dataservice.ide.constant.WSO2DataserviceWizardConstant;

/**
 * Defaults on Data Service Configuration
 */
public class DSPreferencesDefaults {

	// Default value of Configuration
	public static final String PREFERENCE_DS_CONFIG_DEFAULT 
			= WSO2DataserviceWizardConstant.defaultDataServiceConfig;
	
	// Default value of Carbon Home
	public static final String PREFERENCE_CARBON_HOME_DEFAULT 
			= WSO2DataserviceWizardConstant.defaultCarbonHOme;

	/**
	 * @return returns the default setting for data service configuration.
	 */
	public static String getDSConfiguration() {
		return PREFERENCE_DS_CONFIG_DEFAULT;
	}
	
	/**
	 * @return returns the default setting for Carbon Home.
	 */
	public static String getCarbonHome() {
		return PREFERENCE_CARBON_HOME_DEFAULT;
	}

}
