/*
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.ws.dataservice.ide.util;

import org.eclipse.jface.resource.FontRegistry;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Display;

/**
 * Utility class for Font manipulation on Data Services wizard UI
 */
public class FontUtil {
	
	private static FontUtil instance = null;
	private static FontRegistry fontRegistry;
	
	private static String arealBoldString = "arial-bold-text";
	
	protected FontUtil() {
		// singleton
	}
	
	/**
	 * Return the Font Util singleton instance 
	 * @param display : display for the Font registry to init
	 * @return singleton instance 
	 */
	public static FontUtil getInstance(Display display) {
		if(instance == null) {
			instance = new FontUtil();
			fontRegistry = new FontRegistry(display);
			fontRegistry.put(arealBoldString, new FontData[]{new FontData("Arial", 10, SWT.BOLD)} );
		}
		return instance;
	}
		
	/**
	 * Utility method for get font  
	 * @param display : display for the font
	 * @return styled font 
	 */
	public Font getArealBoldFont() {
		return fontRegistry.get(arealBoldString);
	}	
	
}
