/*
 * Copyright 2004,2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.solutions.internal;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.http.HttpService;
import org.osgi.service.http.HttpContext;
import org.eclipse.equinox.http.helper.BundleEntryHttpContext;
import org.eclipse.equinox.http.helper.ContextPathServletAdaptor;
import org.eclipse.equinox.jsp.jasper.JspServlet;
import org.wso2.carbon.component.ComponentEntryHttpContext;

import javax.servlet.Servlet;

/*
* 
*/
public class Activator implements BundleActivator {

    public void start(BundleContext context) throws Exception {
        ServiceReference reference = context.getServiceReference(HttpService.class.getName());
        if (reference != null) {
            final HttpService httpService = (HttpService) context.getService(reference);
            try {
                HttpContext commonContext =
                        new ComponentEntryHttpContext(context.getBundle(), "/web");
                httpService.registerResources("/ds", "/",
                                              commonContext);

                Servlet adaptedJspServlet = new ContextPathServletAdaptor(
                        new JspServlet(context.getBundle(), "/web"),
                        "/ds");
                httpService.registerServlet("/ds/*.jsp", adaptedJspServlet, null,
                                            commonContext);
            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        } else {
            throw new Exception("HttpService is not found.");
        }

    }

    public void stop(BundleContext context) throws Exception {

    }
}
